        DOUBLE PRECISION FUNCTION COUL(Z1,Z2,R1,R2,B1,B2,R,Y10,Y20)
C COULOMB POTENTIAL 
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        PI = 3.1415
        QQ = 1.44
        Y1=DSQRT(5./16/PI)*Y10
        Y2=DSQRT(5./16/PI)*Y20
        KEY = 1
        IF(R+R1-R2.LT.0.) KEY=-1
        IF(R.GE.R1+R2) THEN
        C0 = 1./R
        ELSE
        C0 = 9./2./R1/R1/R1/R2/R2/R2/R*(-R*(4.*(R1+R2)**5/120.+
     /   2.*(R1+R2)**3*R*R/36.)+R*R1*R2/6.*((R1+R2)**3+R*R*(R1+R2))-
     /   ((R+R1-R2)**6+(R+R2-R1)**6)/1440.+(R1-R2)/2.*((R+R1-R2)**5-
     /   (R+R2-R1)**5)/120.+R1*R2*((R+R1-R2)**4+(R+R2-R1)**4)/48.)
        ENDIF
        C1=0.
        C11=0.
        C12=0.
        IF(B1.EQ.0.) THEN
        ELSE
        IF(R.GE.R1+R2) THEN
        C11 = 0.6/R/R/R*R1*R1*B1*Y1
        WRITE(*,*)'C11',C11
        ELSE
        F1=PI/30.*R*R/R1/R1/R2/R2*((R1+R2)**3/R1-R1*R1-3.*R1*R2-
     /   3.*R2*R2)
        F2=
     /   PI/4.*(9.*(R+R2-R1)**7/8./720./R/R/R1/R1/R2*
     /   (1./R/R2-1./R1/R2-1./R/R1)-3.*(R+R2-R1)**6/720./R/R1/R2*
     /   (-1./R/R/R2-1./R1/R1/R2+3./R/R1/R2+3./R/R/R1-3./R/R1/R1)-
     /   3.*(R+R2-R1)**5/120./R/R1/R2*(-1./R1/R2+1./R/R2+1./R/R+
     /   1./R1/R1-3./R/R1)+(R+R2-R1)**4/24./R/R1/R2*(1./R2-3./R1+
     /   3./R)-(R+R2-R1)**3/6./R/R1/R2)
         F3=
     /   KEY*PI/4.*
     /   (9.*(R+R1-R2)**7/8./720./R/R/R1/R1/R2*(-1./R/R2-1./R1/R2+
     /   1./R/R1)-3.*(R+R1-R2)**6/720./R/R1/R2*(-1./R/R/R2-
     /   1./R1/R1/R2-3./R/R1/R2+3./R/R/R1+3./R/R1/R1)-
     /   3.*(R+R1-R2)**5/120./R/R1/R2*(1./R1/R2+1./R/R2-1./R/R-
     /   1./R1/R1-3./R/R1)+(R+R1-R2)**4/24./R/R1/R2*
     /   (1./R2-3./R1-3./R)+(R+R1-R2)**3/6./R/R1/R2)
         WRITE(*,*)'F1',F1,'F2',F2,'F3',F3
         C11 =(F1+F2+F3)*Y1*9.*B1/PI/R2
         WRITE(*,*)'C11',C11
        ENDIF
        ENDIF
        IF(B2.EQ.0.) THEN
        ELSE
        IF(R.GE.R1+R2) THEN
        C12 = 0.6/R/R/R*R2*R2*B2*Y2
        ELSE
        C12 =(PI/30.*R*R/R1/R1/R2/R2*((R1+R2)**3/R2-R2*R2-3.*R1*R2-
     /   3.*R1*R1)+KEY*PI/4.*(9.*(R+R1-R2)**7/8./720./R/R/R2/R2/R1*
     /   (1./R/R1-1./R1/R2-1./R/R2)-3.*(R+R1-R2)**6/720./R/R1/R2*
     /   (-1./R/R/R1-1./R1/R2/R2+3./R/R1/R2+3./R/R/R2-3./R/R2/R2)-
     /   3.*(R+R1-R2)**5/120./R/R1/R2*(-1./R1/R2+1./R/R1+1./R/R+
     /   1./R2/R2-3./R/R2)+(R+R1-R2)**4/24./R/R1/R2*(1./R1-3./R2+
     /   3./R)-(R+R1-R2)**3/6./R/R1/R2)+PI/4.*
     /   (9.*(R+R2-R1)**7/8./720./R/R/R2/R2/R1*(-1./R/R1-1./R1/R2+
     /   1./R/R2)-3.*(R+R2-R1)**6/720./R/R1/R2*(-1./R/R/R1-
     /   1./R1/R2/R2-3./R/R1/R2+3./R/R/R2+3./R/R2/R2)-
     /   3.*(R+R2-R1)**5/120./R/R1/R2*(1./R1/R2+1./R/R1-1./R/R-
     /   1./R2/R2-3./R/R2)+(R+R2-R1)**4/24./R/R1/R2*
     /   (1./R1-3./R2-3./R)+(R+R2-R1)**3/6./R/R1/R2))*Y2*9.*B2/PI/R1
        ENDIF
        ENDIF
        C1=C11+C12
        COUL = Z1*Z2*QQ*(C0+C1)     
        RETURN
        END
C-------------------------------------------------------------------------